program PPIC;

Uses TpString, TpCrt, TpWindow, TpMenu, TpEdit,
      uProg, uEditor, uEWord, uEByte, uEDisasm, uEFuses;


{ callback routine }
procedure ProgressBar( percent:word );far;
var
  winBar : WindowPtr;
  procedure DrawBar( percent:word );
  var
    i : word;
  begin
    for i:=0 to 34 do
    begin
      if i*100>percent*35 then
        FastWriteWindow( '', 2, 3+i, $30 )
      else
        FastWriteWindow( '', 2, 3+i, $30 );
    end;
  end;
begin
  if percent=1001 then
  begin
    MakeWindow( winBar,
                (CurrentWidth-40) div 2, 11,
                (CurrentWidth+40) div 2, 16,
                true, true, true, $30, $30, $50, '');
    DisplayWindow(winBar);
    HiddenCursor;
    WindowText( 1, 'Progress' );
    DrawBar(0);
  end else if percent=1002 then
  begin
    DisposeWindow (EraseTopWindow);
  end else
  begin
    DrawBar(percent);
  end;
end;


procedure InitMenu(var M : Menu);
const
  ColorMenu : MenuColorArray = ($70, $4C, $70, $1F, $71, $70, $70, $08);
begin
  M := NewMenu([#191,#192,#193,#194], nil);
  SubMenu(3,3,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
    MenuMode(false,true,false);
    MenuItem('COM Port        COM.       '#16,1,1,1,' Select COM port');
    SubMenu(32,4,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
      MenuMode(false,true,false);
      MenuItem('. COM1', 1, 6, 301, ' Select COM1' );
      MenuItem('. COM2', 2, 6, 302, ' Select COM2' );
      MenuItem('. COM3', 3, 6, 303, ' Select COM3' );
      MenuItem('. COM4', 4, 6, 304, ' Select COM4' );
      PopSublevel;
    MenuItem('Device          PIC16F8..  '#16,2,1,2,' Select device to program');
    SubMenu(32,5,CurrentHeight+1,Vertical,FrameChars,ColorMenu,'');
      MenuMode(false,true,false);
      MenuItem('. PIC16F84',  1,  9, 101, ' Programming PIC16F84' );
      MenuItem('. PIC16F873', 2, 11, 102, ' Programming PIC16F873' );
      MenuItem('. PIC16F874', 3, 11, 103, ' Programming PIC16F874' );
      MenuItem('. PIC16F876', 4, 11, 104, ' Programming PIC16F876' );
      MenuItem('. PIC16F877', 5, 11, 105, ' Programming PIC16F877' );
      PopSublevel;
    MenuItem('',   3,  0,  901, '' );
    MenuItem('PrgMem dump     0x....*14  '#16, 4,  1,    3, ' Edit program memory' );
    MenuItem('PrgMem disasm   0x....*14  '#16, 5, 11,    4, ' Edit program memory as disasm' );
    MenuItem('EEPROM dump     0x....* 8  '#16, 6,  1,    5, ' Edit EEPROM memory' );
    MenuItem('Fuses                      '#16, 7,  1,    6, ' Configure device options (fuseword)' );
    MenuItem('',   8,  0,  902, '' );
    MenuItem('Program                   F5',   9, 28,  201, ' Program entire device: PRGMEM + EEPROM + FUSES' );
    MenuItem('Erase',                         10,  0,  202, ' Erase and/or unprotect device (unprotect will erase!)' );
    MenuItem('Verify                    F6',  11, 28,  203, ' Verify device against buffer contents' );
    MenuItem('Blank check               F7',  12, 28,  204, ' Check if device is blank(erased)' );
    MenuItem('Read                      F8',  13, 28,  205, ' Read device contents into buffer' );
    MenuItem('',  14,  0,  903, '' );
    MenuItem('Load .HEX',                     15,  1,  206, ' Locate a file and load to buffer' );
    MenuItem('Save .HEX',                     16,  1,  207, ' Save buffer contents to a file' );
    MenuItem('',  17,  0,  904, '' );
    MenuItem('Quit',                          18,  1, 1001, ' Leave program' );
    PopSublevel;
  DisableMenuItem(M,901);
  DisableMenuItem(M,902);
  DisableMenuItem(M,903);
  DisableMenuItem(M,904);
  ResetMenu(M);
end;

procedure UpdateMenu(var M:Menu; var programmer:TProgrammer);
var
  iKey : MenuKey;
  ItemName : string;
begin
  for iKey:=101 to 105 do
  begin
    if GetMenuItemName(M, iKey, ItemName) then
    begin
      if Copy(ItemName,3,200)=programmer.m_Device^.m_sName then
        ItemName[1] := #251
      else
        ItemName[1] := #32;
      SetMenuItemName(M, iKey, ItemName);
    end;
  end;

  if GetMenuItemName(M, 2, ItemName) then
  begin
    ItemName := Copy(ItemName,1,16) +
                programmer.m_Device^.m_sName +
                ' ' +
                Copy(ItemName,16+Length(programmer.m_Device^.m_sName)+2,200);
    SetMenuItemName(M, 2, ItemName);
  end;

  if GetMenuItemName(M, 3, ItemName) then
  begin
    ItemName := Copy(ItemName,1,18) +
                HexW(programmer.m_Device^.m_bcProgram) +
                Copy(ItemName,23,200);
    SetMenuItemName(M, 3, ItemName);
  end;

  if GetMenuItemName(M, 4, ItemName) then
  begin
    ItemName := Copy(ItemName,1,18) +
                HexW(programmer.m_Device^.m_bcProgram) +
                Copy(ItemName,23,200);
    SetMenuItemName(M, 4, ItemName);
  end;

  if GetMenuItemName(M, 5, ItemName) then
  begin
    ItemName := Copy(ItemName,1,18) +
                HexW(programmer.m_Device^.m_bcEEPROM) +
                Copy(ItemName,23,200);
    SetMenuItemName(M, 5, ItemName);
  end;


  for iKey:=301 to 304 do
  begin
    if GetMenuItemName(M, iKey, ItemName) then
    begin
      if Ord(ItemName[6])-$30=programmer.Port then
        ItemName[1] := #251
      else
        ItemName[1] := #32;
      SetMenuItemName(M, iKey, ItemName);
    end;
  end;

  if GetMenuItemName(M, 1, ItemName) then
  begin
    ItemName[20] := Chr(programmer.Port+$30);
    SetMenuItemName(M, 1, ItemName);
  end;

  DrawSubMenu(M^.Root,nil);
end;




procedure MessageBox( title:String; bSuccess:Boolean );
var
  winBox : WindowPtr;
  l : word;
  color : byte;
begin
  l := Length(title);
  if l<30 then l:=30;

  color := $4F;
  if bSuccess then color := $2F;

  MakeWindow( winBox,
              (CurrentWidth-(l+9)) div 2, 11,
              (CurrentWidth+(l+9)) div 2, 15,
              true, true, true, color, color, color, '');
  DisplayWindow(winBox);
  HiddenCursor;
  FastWriteWindow( title, 2, 5, color );

  WindowText( 1, 'Message' );
  WindowText( 3, 'Press any key' );

  ReadKeyWord;

  DisposeWindow (EraseTopWindow);
end;



function OpenFileDialog( var FName:string ) : boolean;
var
  Escaped : Boolean;
  winDlg : WindowPtr;
begin
  FName := '';

  MakeWindow( winDlg, 15, 10, 60, 15,
                 true, true, true, $7F, $7F, $00, '');
  DisplayWindow(winDlg);

  WindowText( 1, 'Open file' );
  WindowText( 3, 'ESC Exit  ENTER Accept' );

  ReadString('File: ', 12, 18, 33, $70, $1E, $1C, Escaped, FName);
  DisposeWindow (EraseTopWindow);

  OpenFileDialog := (not Escaped) and (FName<>'');
end;

function SaveFileDialog( var FName:string ) : boolean;
var
  Escaped : Boolean;
  winDlg : WindowPtr;
begin
  FName := '';

  MakeWindow( winDlg, 15, 10, 60, 15,
                 true, true, true, $7F, $7F, $00, '');
  DisplayWindow(winDlg);

  WindowText( 1, 'Save file' );
  WindowText( 3, 'ESC Exit  ENTER Accept' );

  ReadString('File: ', 12, 18, 33, $70, $1E, $1C, Escaped, FName);
  DisposeWindow (EraseTopWindow);

  SaveFileDialog := (not Escaped) and (FName<>'');
end;


var
  programmer : TProgrammer;
  winMid : WindowPtr;
  x,y:integer;
  M : Menu;
  ItemName : string;
  Ch : Char;
  Key : MenuKey;
  FName : string;
  i : word;
  BatchCmd : string;
  BatchArg : string;
label
  __quit;
begin
  ShadowAttr := $08;
  Shadow := true;

  MakeWindow( winMid, 1, 1, CurrentWidth, CurrentHeight+1,
                 false, false, true, $00, $00, $00, '');
  DisplayWindow(winMid);
  for x:=1 to CurrentWidth do
  begin
    FastWriteWindow(#32,1,x,$70);
    for y:=2 to CurrentHeight do
      FastWriteWindow(#176,y,x,$71);
    FastWriteWindow(#32,CurrentHeight+1,x,$70);
  end;
  FastWriteWindow('Programmer for PIC16F87x & PIC16F84',1,2,$70);
  FastWriteWindow(' copyLeft DP 2000  http://zhengxi.da.ru ',1,CurrentWidth-41,$70);



  programmer.Init(ProgressBar);
  programmer.Execute( 'PORT', 'COM1' );
  programmer.Execute( 'DEVICE', 'PIC16F84' );

  InitMenu(M);
  UpdateMenu( M, programmer );

  { BATCH JOB }
  for i:=1 to ParamCount do
  begin
    BatchCmd := ParamStr(i);
    BatchArg := '';
    x := Pos(':',BatchCmd );
    if x<>0 then
    begin
      BatchArg := Copy(BatchCmd,x+1,255);
      BatchCmd := Copy(BatchCmd,1,x-1);
    end;

    if Equal=CompUCString(BatchCmd,'QUIT') then goto __quit;

    if not programmer.Execute( BatchCmd, BatchArg ) then
    begin
      MessageBox( 'Batch job error: "'+ParamStr(i)+ '"', false );
      break;
    end;
    UpdateMenu( M, programmer );
  end;



  repeat
    Key := MenuChoice(M, Ch);

    if Ch=#27 then continue;

    case Ch of
      #191: Key := 201;
      #192: Key := 203;
      #193: Key := 204;
      #194: Key := 205;
    end;

    case Key of

    101..105:
      if GetMenuItemName(M, Key, ItemName) then
      begin
        EraseSubMenu(M^.Active);
        PopSubMenu(M);
        programmer.Execute( 'DEVICE', Copy(ItemName,3,200) );
        UpdateMenu( M, programmer );
      end;

    301..304:
      if GetMenuItemName(M, Key, ItemName) then
      begin
        EraseSubMenu(M^.Active);
        PopSubMenu(M);
        programmer.Execute( 'PORT', 'COM'+ItemName[6] );
        UpdateMenu( M, programmer );
      end;

    3:
        with programmer.m_Device^ do
            WordHexEditor( m_memProgram, m_bcProgram );

    4:
        with programmer.m_Device^ do
            DisasmHexEditor( m_memProgram, m_bcProgram, m_sName );

    5:
        with programmer.m_Device^ do
          ByteHexEditor( m_memEEPROM, m_bcEEPROM );

    6:
        with programmer.m_Device^ do
          FusesEditor( @m_memFuses, m_sName );


    201:  {Program}

      if programmer.Execute( 'PROGRAM', '' ) then
        MessageBox( 'Programming complete', true )
      else
        MessageBox( 'ERROR in programming device', false );


    202:  {Erase}
      if programmer.Execute( 'ERASE', '' ) then
        MessageBox( 'Device erased', true );

    203:  {Verify}
      if programmer.Execute( 'VERIFY', '' ) then
        MessageBox( 'Verify OK', true )
      else
        MessageBox( 'Verify FAILED', false );

    204:  {Blank check}
      if programmer.Execute( 'BLANKCHECK', '' ) then
        MessageBox( 'Device is blank', true )
      else
        MessageBox( 'Device is NOT blank', false );

    205:  {Read device}
      if programmer.Execute( 'READ', '' ) then
        MessageBox( 'Read OK', true );

    206:  {Load .HEX}
      if OpenFileDialog(FName) then
        if programmer.Execute( 'LOAD', FName ) then
          MessageBox( 'Data was loaded successfully', true )
        else
          MessageBox( 'Data was NOT loaded', false );


    207:  {Save .HEX}
      if SaveFileDialog(FName) then
        if programmer.Execute( 'SAVE', FName ) then
          MessageBox( 'Data was saved successfully', true )
        else
          MessageBox( 'Data was NOT saved', false );

    1001:  {Quit}
      break;
    end;

  until false;

__quit:

  programmer.Free;
  EraseMenu(M, False);
  DisposeWindow (EraseTopWindow);

end.