unit uEByte;

interface

procedure ByteHexEditor( pMem:Pointer; bc:Word );

implementation

uses TpString, TpWindow, TpCrt, uEditor, uDev {, uDisasm};

type
  TByteEditor = object(TAbsEditor)
   { procedure     CalcAddress; virtual;}
    procedure     PaintLine( y:Word ); virtual;
    constructor   Init( pMem:Pointer; bc:Word  );
  end;

constructor TByteEditor.Init( pMem:Pointer; bc:Word  );
begin
  inherited Init( pMem, bc, 1, $FF, 16 );
end;


procedure TByteEditor.PaintLine( y:Word );
var
  x : word;
  color : byte;
  offset : word;
begin
  if m_pEdit<>nil then
  begin
    FastWriteWindow( ' '+HexW((y-1+m_StartLine)*m_LineItems)+':', y, 1, $17 );
    for x:=0 to m_LineItems-1 do
    begin
      offset := (y-1+m_StartLine)*m_LineItems+x;
      if offset<m_bc then
      begin
        color := $1E;
        if PByteArray(m_pEdit)^[offset]<>PByteArray(m_pMem)^[offset] then color := $1C;
        FastWriteWindow( HexB(PByteArray(m_pEdit)^[offset]), y, m_DumpL+m_ItemWidth*x, color );
        FastWriteWindow( ChrDot(PByteArray(m_pEdit)^[offset]), y, m_TextL+x, color );
      end else
      begin
        FastWriteWindow( ' ', y, m_DumpL+m_ItemWidth*x, $10 );
        FastWriteWindow( ' ', y, m_TextL+x, $10 );
      end;
    end;
  end;
end;


procedure ByteHexEditor( pMem:Pointer; bc:Word);
var
  e : TByteEditor;
  winTmp : WindowPtr;
begin
  MakeWindow( winTmp, 3, 3, 77, 20,
                 true, true, true, $1E, $1F, $00, '');
  DisplayWindow(winTmp);

  WindowText( 0, '0000..'+HexW(bc-1) );
  WindowText( 1, 'EEPROM memory' );
  WindowText( 3, 'DEL Undo  ESC Cancel  ENTER Save' );

  e.Init( pMem, bc );
  e.Execute;
  e.Free;

  DisposeWindow (EraseTopWindow);
end;

end.