unit uEDisasm;

interface

procedure DisasmHexEditor( pMem:Pointer; bc:Word; const processor:String);

implementation

uses TpString, TpCrt, TpWindow, uEditor, uDev, uDisasm;

type
  TDisasmEditor = object(TAbsEditor)
    m_sProcessor : string;
    procedure     PaintLine( y:Word ); virtual;
    constructor   Init( pMem:Pointer; bc:Word; const processor:String );
  end;

constructor TDisasmEditor.Init( pMem:Pointer; bc:Word; const processor:String );
var
  i : integer;
begin
  inherited Init( pMem, bc, 2, $3FFF, 1 );
  m_sProcessor := processor;
end;


procedure TDisasmEditor.PaintLine( y:Word );
var
  i : word;
  w : word;
  color : byte;
  offset : word;
  sCmnt : string;
begin
  if m_pEdit<>nil then
  begin
    offset := (y-1+m_StartLine)*m_LineItems;
    FastWriteWindow( ' '+HexW(offset)+':', y, 1, $17 );
    if offset<m_bc then
    begin
      color := $1E;
      w := PWordArray(m_pEdit)^[offset];
      if w<>PWordArray(m_pMem)^[offset] then color := $1C;
      FastWriteWindow( HexW(w), y, m_DumpL, color );
      for i:=m_DumpL+5 to WinWidth+1 do
        FastWriteWindow( ' ', y, i, $1F );
      FastWriteWindow( Disasm(w,m_sProcessor,sCmnt), y, m_DumpL+5, $1F );
      if Length(sCmnt)<>0 then
        FastWriteWindow( '; '+sCmnt, y, m_DumpL+21, $17 );
    end else
    begin
      FastWriteWindow( '    ', y, m_DumpL, $10 );
    end;
  end;
end;


procedure DisasmHexEditor( pMem:Pointer; bc:Word; const processor:string );
var
  e : TDisasmEditor;
  winTmp : WindowPtr;
begin
  MakeWindow( winTmp, 11, 2, 77, CurrentHeight-1,
    true, true, true, $1E, $1F, $00, '');
  DisplayWindow(winTmp);

  WindowText( 0, '0000..'+HexW(bc-1) );
  WindowText( 1, 'Program memory' );
  WindowText( 3, 'DEL Undo  ESC Cancel  ENTER Save' );

  e.Init( pMem, bc, processor );
  e.Execute;
  e.Free;

  DisposeWindow (EraseTopWindow);
end;

end.